using System;
using System.Windows.Forms;
using Eco.Windows.Forms;

namespace EcoMvcExample_Admin
{
	static class Program
	{
        private static EcoMvcExample.EcoMvcExampleEcoSpace ecoSpace;

		/// <summary>
		/// The global EcoSpace instance.
		/// </summary>
        public static EcoMvcExample.EcoMvcExampleEcoSpace EcoSpace
		{
			get { return ecoSpace; }
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);
			WinFormDequeuer.Active = true;
			Form mainForm = null;
			try
			{
                ecoSpace = new EcoMvcExample.EcoMvcExampleEcoSpace();
				ecoSpace.Active = true;
				mainForm = new ProgramStart(ecoSpace);

			}
			catch (Exception e)
			{
				new ThreadExceptionDialog(e).ShowDialog();
				throw;
			}

            try
            {
                Application.Run(mainForm);
            }
            finally
            {
                if ( (ecoSpace.DirtyList != null) && (ecoSpace.DirtyList.HasDirtyObjects()) )
                {
                    ecoSpace.UpdateDatabase();
                }
                ecoSpace.Dispose();
            }
		}
	}
}
