﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Eco.Services;

using NUnit.Framework;

using EcoMvcExample;
using EcoMvcExample.MvcWebsite.Controllers;


namespace EcoMvcExample.MvcWebsite.Tests.Models
{
    [TestFixture]
    public class EcoSpaceTest
    {
        // Test Used Variables
        EcoMvcExampleBaseController controller = null;

        [SetUp]
        public void SetupEnvironment()
        {
            // This code is basically what occur's at the start of each test
            controller = new EcoMvcExampleBaseController();
            controller.EcoSpaceType = typeof(TestMemoryEcoSpace);
        }

        [TearDown]
        public void RemoveEnvironment()
        {
            controller = null;
        }

        [Test]
        public void EcoSpaceNotNull()
        {
            Assert.IsNotNull(controller.EcoSpace);
        }

        [Test]
        public void EcoSpaceReturnsCorrectType()
        {
            // These tests are for the TestMemoryEcoSpace
            Assert.AreEqual(controller.EcoSpaceType, typeof(TestMemoryEcoSpace));
            Assert.AreEqual(controller.EcoSpace.GetType(), typeof(TestMemoryEcoSpace));
        }

        [Test]
        public void EcoSpaceReturnsIOclService()
        {
            // Test to see if we can get an instance of the IOclService for use
            IOclService os = controller.EcoSpace.GetEcoService<IOclService>();
            Assert.IsNotNull(os);
        }

        [Test]
        public void EcoSpaceReturnsIOclPsService()
        {
            // Test to see if we can get an instance of the IOclPsService for use
            IOclPsService ops = controller.EcoSpace.GetEcoService<IOclPsService>();
            Assert.IsNotNull(ops);
        }

        [Test]
        public void EcoSpaceReturnsIPersistenceService()
        {
            // Test to see if we can get an instance of the IPersistenceService for use
            IPersistenceService ps = controller.EcoSpace.GetEcoService<IPersistenceService>();
            Assert.IsNotNull(ps);
        }

        [Test]
        public void EcoSpaceReturnsIDirtyListService()
        {
            // Test to see if we can get an instance of the IDirtyListService for use
            IDirtyListService dls = controller.EcoSpace.GetEcoService<IDirtyListService>();
            Assert.IsNotNull(dls);
        }
    }
}