﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using NUnit.Framework;

using Eco.Handles;

using EcoMvcExample.Model;
using EcoMvcExample.MvcWebsite.Models;


namespace EcoMvcExample.MvcWebsite.Tests.Models
{
    [TestFixture]
    public class TaskUserHelperTests
    {
        // test variables
        TestMemoryEcoSpace ecoSpace = null;


        [SetUp]
        public void SetupEnvironment()
        {
            ecoSpace = new TestMemoryEcoSpace();
            ecoSpace.Active = true;
        }

        [TearDown]
        public void TearDownEnvironment()
        {
            ecoSpace = null;
        }

        [Test]
        public void GetAllUsers()
        {
            // Create the test objects.
            TestObjectsHelper.CreateTestObjects(this.ecoSpace, true);

            // Try to work against the test objects.
            ExpressionHandle users = TaskUserHelper.GetAllUsers(this.ecoSpace);
            Assert.IsNotNull(users, "Users returned from GetAllUsers is null!");
            IList usersList = users.GetList();
            Assert.IsNotNull(usersList, "List returned from ExpressionHandle GetList is null!");
            Assert.AreEqual(2, usersList.Count, "The number of users returned is incorrect!");
        }

        [Test]
        public void GetUser()
        {
            // Create the test objects.
            TestObjectsHelper.CreateTestObjects(this.ecoSpace, true);

            // Try to work against the test objects.
            TaskUser tuFirst = TaskUserHelper.GetUser(this.ecoSpace, "test1");
            Assert.IsNotNull(tuFirst, "GetUser returned null on first test!");

            TaskUser tuSecond = TaskUserHelper.GetUser(this.ecoSpace, "test2");
            Assert.IsNotNull(tuSecond, "GetUser returned null on second test!");
        }
    }
}
