﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace EcoMvcExample.MvcWebsite
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");


            /// NOTES:
            /// ======
            /// Whilst MVC applications should work correctly out of the compiler with Windows
            /// Web Server 2008 (and probably others based on 2008), they do not with 
            /// Windows 2003 Server.
            /// 
            /// To run this in a Windows 2003 Server environment, you need to adjust the default
            /// route a little from the basic setting, and also need something like the Helicon
            /// ISAPI_Rewrite plugin to change things a little firstly providing this type of
            /// script to control the ISAPI_Rewrite module for the specific website.
            /// 
            /// #--------------------------------------------------
            /// # Helicon ISAPI_Rewrite configuration file
            /// # Version 3.1.0.47
            /// 
            /// RewriteEngine on
            /// 
            /// RewriteRule ^$ Home [NC]
            /// RewriteRule ^([\w]*)$ $1.mvc [NC]
            /// RewriteRule ^(?!Content)([\w]*)/(.*) $1.mvc/$2 [NC]
            /// #--------------------------------------------------
            /// 
            /// 
            /// Next, you need to change the default route from this:
            /// 
            /// "{controller}/{action}/{id}"
            /// 
            /// to this instead:
            /// 
            /// "{controller}.mvc/{action}/{id}"
            /// 
            /// To get Windows 2003 Server to correctly deal with the ASP.NET MVC extensions.
            /// This is why you need the ISAPI_Rewrite, to try to make it appear correctly to the
            /// users of the website.

            routes.MapRoute(
                "Default",                                              // Route name
                "{controller}/{action}/{id}",                           // URL with parameters
                //"{controller}.mvc/{action}/{id}",                     // URL with parameters for Windows 2003 Server
                new { controller = "Home", action = "Index", id = "" }  // Parameter defaults
                // (Personally I hate anonymous types and peoples laziness, very easy to get string typo's in them
                // which makes the compiler useless at compile time checking that settings are correct).
            );

            // For Windows 2003 Server
            routes.MapRoute(
                "Default.mvc",                                          // Route name
                "{controller}.mvc/{action}/{id}",                       // URL with parameters
                //"{controller}.mvc/{action}/{id}",                     // URL with parameters for Windows 2003 Server
                new { controller = "Home", action = "Index", id = "" }  // Parameter defaults
                // (Personally I hate anonymous types and peoples laziness, very easy to get string typo's in them
                // which makes the compiler useless at compile time checking that settings are correct).
            );
        }

        protected void Application_Start()
        {
            RegisterRoutes(RouteTable.Routes);
        }
    }
}