﻿using System;
using System.Collections.Generic;
using System.Linq;

using Eco.ObjectRepresentation;
using Eco.Services;

using Eco.Handles;
using Eco.Web;


namespace EcoMvcExample.MvcWebsite.Models
{
    public static class EcoHelper
    {
        public static string IdForObject(IObject obj)
        {
            IExternalIdService es = obj.ServiceProvider.GetEcoService<IExternalIdService>();
            return es.IdForObject(obj);
        }

        public static IObjectInstance ObjectFromId(string ID, IEcoServiceProvider ecoProvider)
        {
            IExternalIdService es = ecoProvider.GetEcoService<IExternalIdService>();
            return es.ObjectForId(ID);
        }

        public static EcoMvcExampleEcoSpace GetEcospace()
        {
            EcoSpaceStrategyHandler ecoSpaceProvider = new EcoSpaceStrategyHandler(EcoSpaceStrategyHandler.SessionStateMode.Never, typeof(EcoMvcExampleEcoSpace));
            if (ecoSpaceProvider != null)
            {
                return ecoSpaceProvider.GetEcoSpace() as EcoMvcExampleEcoSpace;
            }
            else
                return null;
        }
    }
}
